﻿using System;
using System.Collections.Generic;

using System.Text;

namespace Merthsoft.CALCnet {
	/// <summary>
	/// A packet that is the gcnclient telling the metahub about a calculator it has
	/// </summary>
	class CalcPacket : CALCnetPacket {
		/// <summary>
		/// Gets the calcID of the packet
		/// </summary>
		public byte[] CalcID { get; protected set; }

		/// <summary>
		/// Creates a new CalcPacket ('c' type) with the given calcID.
		/// </summary>
		/// <param name="calcID">The ID of the packet's owning calc.</param>
		public CalcPacket(ICollection<byte> calcID) {
			if (calcID.Count != 5) {
				throw new ArgumentException("calcID must be 5 bytes long");
			}
			CalcID = (byte[])calcID;
			Type = PacketType.Calculator;
			List<byte> payload = new List<byte>();
			foreach (byte b in calcID) {
				byte b1 = b.ToString("X2").ToByteArray()[0];
				byte b2 = b.ToString("X2").ToByteArray()[1];
				payload.Add(b1);
				payload.Add(b2);
			}
			Payload = payload;
		}
	}
}
